// GuiView.cpp : implementation file
//

#include "stdafx.h"
#include "gui.h"
#include "GuiView.h"

#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGuiView

IMPLEMENT_DYNCREATE(CGuiView, CListView)

CGuiView::CGuiView()
{
}

CGuiView::~CGuiView()
{
}


BEGIN_MESSAGE_MAP(CGuiView, CListView)
	//{{AFX_MSG_MAP(CGuiView)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_COMMAND(ID_EDIT_HI, OnEditHi)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGuiView drawing

void CGuiView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here

}

/////////////////////////////////////////////////////////////////////////////
// CGuiView diagnostics

#ifdef _DEBUG
void CGuiView::AssertValid() const
{
	CListView::AssertValid();
}

void CGuiView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGuiView message handlers

void CGuiView::OnFileClose() 
{
	// TODO: Add your command handler code here
	GetParent()->SendMessage(WM_CLOSE);
}

BOOL CGuiView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	cs.style |= LVS_REPORT | LVS_SHOWSELALWAYS;
	return CListView::PreCreateWindow(cs);
}

int CGuiView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CListView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	ListView_SetExtendedListViewStyle(GetSafeHwnd(),
		                              LVS_EX_FULLROWSELECT |
									  LVS_EX_SUBITEMIMAGES |
									  LVS_EX_CHECKBOXES);

	GetListCtrl().InsertColumn(0, _T("No"), LVCFMT_LEFT, 50, 0);
	GetListCtrl().InsertColumn(1, _T("Privilege"), LVCFMT_LEFT, 150, 0);
	return 0;
}

void CGuiView::OnSize(UINT nType, int cx, int cy) 
{
	CListView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if(GetListCtrl().GetSafeHwnd())
	{
		CRect r;
		GetClientRect(&r);

		GetListCtrl().SetColumnWidth(0, r.Width() * 0.15);
		GetListCtrl().SetColumnWidth(1, r.Width() * 0.85);
	}

}

void CGuiView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	dc.TextOut(0, 20, "This FRAME - VIEW - DOCUMENT is inside ATL DLL!");
	// Do not call CListView::OnPaint() for painting messages
}

void CGuiView::OnEditHi() 
{
	// TODO: Add your command handler code here
	AfxMessageBox(_T("Hi"));
}
